//Создание задачи диспетчерского вызова прочих задач
function LocalManageSystemFormalModelingProjectCmd(ProjectDirectory,..//Имя директории проекта
                                                   ProjectName,..//Имя проекта
                                                   creatingProject,..//Создавать ли проект
                                                   deletingProject,..//Удалять ли проект
                                                   resultsFiles,..//Файлы с результатами данных
                                                   resultsFilesDirectory..//Директория, в которую скопируются файлы результатов
                                                   )
    //Анализируем аргументы
    select argn(2)
    case 0 then
        ProjectDirectory = pwd();
        ProjectName = [];//По умолчанию спрашиваем у пользователя
        creatingProject = [];//По умолчанию спрашиваем у пользователя
        deletingProject = [];//По умолчанию спрашиваем у пользователя
        resultsFiles = [];//По умолчанию спрашиваем у пользователя
        resultsFilesDirectory = [];//По умолчанию спрашиваем у пользователя
    case 1 then
        ProjectName = [];//По умолчанию спрашиваем у пользователя
        creatingProject = [];//По умолчанию спрашиваем у пользователя
        deletingProject = [];//По умолчанию спрашиваем у пользователя
        resultsFiles = [];//По умолчанию спрашиваем у пользователя
        resultsFilesDirectory = [];//По умолчанию спрашиваем у пользователя
    case 2 then
        creatingProject = [];//По умолчанию спрашиваем у пользователя
        deletingProject = [];//По умолчанию спрашиваем у пользователя
        resultsFiles = [];//По умолчанию спрашиваем у пользователя
        resultsFilesDirectory = [];//По умолчанию спрашиваем у пользователя
    case 3 then
        if type(creatingProject) == 10 then
            resultsFiles = creatingProject;
            creatingProject = [];//По умолчанию спрашиваем у пользователя
        else
            resultsFiles = [];//По умолчанию спрашиваем у пользователя
        end
        deletingProject = [];//По умолчанию спрашиваем у пользователя
        resultsFilesDirectory = [];//По умолчанию спрашиваем у пользователя
    case 4 then
        if type(creatingProject) == 10 then
            resultsFiles = creatingProject;
            resultsFilesDirectory = deletingProject;
            creatingProject = [];//По умолчанию спрашиваем у пользователя
            deletingProject = [];//По умолчанию спрашиваем у пользователя
        else
            resultsFiles = [];
            resultsFilesDirectory = [];//По умолчанию спрашиваем у пользователя
        end
    case 5 then
        if type(deletingProject) == 10 then
            resultsFilesDirectory = resultsFiles;
            resultsFiles = deletingProject;
            deletingProject = [];//По умолчанию спрашиваем у пользователя
        else
            resultsFilesDirectory = [];//По умолчанию спрашиваем у пользователя
        end
    end
    
    //Проверяем корректность аргументов
    if (type(ProjectDirectory) ~= 10) ||..
       (size(ProjectDirectory,"*") > 1) then
        error("The arguments ProjectDirectory of function LocalManageSystemFormalModelingProjectCmd must be scalar string");
    end
    if (~isempty(ProjectName)) &&..
       ((type(ProjectName) ~= 10) ||..
        (size(ProjectName,"*") > 1)) then
        error("The arguments ProjectName of function LocalManageSystemFormalModelingProjectCmd must be scalar string");
    end
    if (~isempty(creatingProject)) &&..
       ((type(creatingProject) ~= 4) ||..
        (size(creatingProject,"*") > 1)) then
        error("The arguments creatingProject of function LocalManageSystemFormalModelingProjectCmd must be scalar boolean");
    end
    if (~isempty(deletingProject)) &&..
       ((type(deletingProject) ~= 4) ||..
        (size(deletingProject,"*") > 1)) then
        error("The arguments deletingProject of function LocalManageSystemFormalModelingProjectCmd must be scalar boolean");
    end
    if (~isempty(resultsFiles)) && (type(resultsFiles) ~= 10) then
        error("The arguments resultsFiles of function LocalManageSystemFormalModelingProjectCmd must be matrix of string");
    end
    if (~isempty(resultsFilesDirectory)) &&..
       ((type(resultsFilesDirectory) ~= 10) ||..
        (size(resultsFilesDirectory,"*") > 1)) then
        error("The arguments resultsFilesDirectory of function LocalManageSystemFormalModelingProjectCmd must be scalar string");
    end
    
    //Обрабатываем аргументы
    if isempty(ProjectDirectory) then
        ProjectDirectory = pwd();
    end
    
    //Типовые вопросы
    endTasksStrEt = "Are all tasks solved?";
    lEndTasksStrEt = length(endTasksStrEt);
    createProjectStrEt = "Create project?";
    lCreateProjectStrEt = length(createProjectStrEt);
    projectNameStrEt = "Name of project:";
    lProjectNameStrEt = length(projectNameStrEt);
    deleteProjectStrEt = "Delete project?";
    lDeleteProjectStrEt = length(deleteProjectStrEt);
    reseiveRezultsFilesStrEt = "Receive rezults'' datas files?";
    lReseiveRezultsFilesStrEt = length(reseiveRezultsFilesStrEt);
    rezultsFilesStrEt = "Results'' files names:";
    lRezultsFilesStrEt = length(rezultsFilesStrEt);
    rezultsFilesDirectoryStrEt = "Results'' files directory(ies) name:";
    lRezultsFilesDirectoryStrEt = length(rezultsFilesDirectoryStrEt);
    
    //Функция получения сообщения от пользователя
    function [msg]=ReadUserFunction(askStr)
        askStr = stripblanks(askStr);//Удаляем лишние пробелы
        if part(askStr,[1:lEndTasksStrEt]) == endTasksStrEt then
            msg = "y";
        elseif (part(askStr,[1:lCreateProjectStrEt]) == createProjectStrEt) &&.. 
               (~isempty(creatingProject)) then
            if creatingProject then
                msg = "Y";
            else
                msg = "N";
            end
        elseif (part(askStr,[1:lProjectNameStrEt]) == projectNameStrEt) &&.. 
               (~isempty(ProjectName)) then
            disp("Name of project: " + ProjectName);
            msg = ProjectName;
        elseif (part(askStr,[1:lDeleteProjectStrEt]) == deleteProjectStrEt) &&.. 
               (~isempty(deletingProject)) then
            if deletingProject then
                msg = "Y";
            else
                msg = "N";
            end
        elseif (part(askStr,[1:lReseiveRezultsFilesStrEt]) == reseiveRezultsFilesStrEt) &&.. 
               (~isempty(resultsFiles)) then
            msg = "Y";
        elseif (part(askStr,[1:lRezultsFilesStrEt]) == rezultsFilesStrEt) &&.. 
               (~isempty(resultsFiles)) then
            msg = strcat(resultsFiles,",");
        elseif (part(askStr,[1:lRezultsFilesDirectoryStrEt]) == rezultsFilesDirectoryStrEt) &&.. 
               (~isempty(resultsFilesDirectory)) then
            msg = resultsFilesDirectory;
        else
            msg = input(askStr + " ","s");
        end
    endfunction
    
    //Создаем и выполняем проект
    LocalManageSystemFormalModelingProject('disp',..//Функция нештатных ситуаций
                                           'ReadUserFunction',..//Функция получения сообщения
                                           'disp',..//Функция отправки сообщения
                                           ProjectDirectory..//Имя директории проекта
                                           );
endfunction
